Index: uspace/app/bdsh/cmds/modules/sleep/sleep.c
===================================================================
--- uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -38,5 +38,5 @@
 #include "cmds.h"
 
-static const char *cmdname = "sleep";
+static char *cmdname = "sleep";
 
 /* Dispays help for sleep in various levels */
Index: uspace/app/bdsh/cmds/modules/touch/touch.c
===================================================================
--- uspace/app/bdsh/cmds/modules/touch/touch.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/touch/touch.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -47,5 +47,5 @@
 #include "cmds.h"
 
-static const char *cmdname = "touch";
+static char *cmdname = "touch";
 
 /* Dispays help for touch in various levels */
Index: uspace/app/bdsh/errors.c
===================================================================
--- uspace/app/bdsh/errors.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/errors.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -47,5 +47,5 @@
 /* Look up errno in cl_errors and return the corresponding string.
  * Return NULL if not found */
-static const char *err2str(int err)
+static char *err2str(int err)
 {
 
Index: uspace/app/bdsh/errstr.h
===================================================================
--- uspace/app/bdsh/errstr.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/errstr.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -4,5 +4,5 @@
 /* Simple array to translate error codes to meaningful strings */
 
-static const char *cl_errors[] = {
+static char *cl_errors[] = {
 	"Success",
 	"Failure",
@@ -18,5 +18,5 @@
 };
 
-static const char *err2str(int);
+static char *err2str(int);
 
 #endif
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/exec.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -120,5 +120,5 @@
 	free(found);
 
-	tid = task_spawn(tmp, (const char **) argv);
+	tid = task_spawn((const char *)tmp, argv);
 	free(tmp);
 
Index: uspace/app/bdsh/scli.h
===================================================================
--- uspace/app/bdsh/scli.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/scli.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -6,5 +6,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 	char *line;
 	char *cwd;
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/edit/edit.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -475,7 +475,8 @@
 static void file_save_as(void)
 {
-	const char *old_fname = (doc.file_name != NULL) ? doc.file_name : "";
-	char *fname;
-	
+	char *old_fname, *fname;
+	int rc;
+
+	old_fname = (doc.file_name != NULL) ? doc.file_name : "";
 	fname = filename_prompt("Save As", old_fname);
 	if (fname == NULL) {
@@ -484,5 +485,5 @@
 	}
 
-	int rc = file_save(fname);
+	rc = file_save(fname);
 	if (rc != EOK)
 		return;
@@ -818,13 +819,15 @@
 	spt_t caret_pt;
 	coord_t coord;
+	char *fname;
+	int n;
 
 	tag_get_pt(&pane.caret_pos, &caret_pt);
 	spt_get_coord(&caret_pt, &coord);
 
-	const char *fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
+	fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
 
 	console_goto(con, 0, scr_rows - 1);
 	console_set_color(con, COLOR_WHITE, COLOR_BLACK, 0);
-	int n = printf(" %d, %d: File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
+	n = printf(" %d, %d: File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
 	    "Ctrl-E Save As", coord.row, coord.column, fname);
 	printf("%*s", scr_columns - 1 - n, "");
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/getterm/getterm.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -69,7 +69,7 @@
 }
 
-static task_id_t spawn(const char *fname)
+static task_id_t spawn(char *fname)
 {
-	const char *args[2];
+	char *args[2];
 	
 	args[0] = fname;
Index: uspace/app/getterm/version.c
===================================================================
--- uspace/app/getterm/version.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/getterm/version.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,18 +40,18 @@
 #include "version.h"
 
-static const char *release = STRING(RELEASE);
-static const char *name = STRING(NAME);
-static const char *arch = STRING(UARCH);
+static char *release = STRING(RELEASE);
+static char *name = STRING(NAME);
+static char *arch = STRING(UARCH);
 
 #ifdef REVISION
-	static const char *revision = ", revision " STRING(REVISION);
+	static char *revision = ", revision " STRING(REVISION);
 #else
-	static const char *revision = "";
+	static char *revision = "";
 #endif
 
 #ifdef TIMESTAMP
-	static const char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
+	static char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
 #else
-	static const char *timestamp = "";
+	static char *timestamp = "";
 #endif
 
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/init/init.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -62,5 +62,5 @@
 static bool mount_root(const char *fstype)
 {
-	const char *opts = "";
+	char *opts = "";
 	const char *root_dev = "bd/initrd";
 	
@@ -117,7 +117,7 @@
 }
 
-static void spawn(const char *fname)
-{
-	const char *argv[2];
+static void spawn(char *fname)
+{
+	char *argv[2];
 	struct stat s;
 	
@@ -134,7 +134,7 @@
 }
 
-static void srv_start(const char *fname)
-{
-	const char *argv[2];
+static void srv_start(char *fname)
+{
+	char *argv[2];
 	task_id_t id;
 	task_exit_t texit;
@@ -168,7 +168,7 @@
 }
 
-static void console(const char *dev)
-{
-	const char *argv[3];
+static void console(char *dev)
+{
+	char *argv[3];
 	char hid_in[DEVMAP_NAME_MAXLEN];
 	int rc;
@@ -193,7 +193,7 @@
 }
 
-static void getterm(const char *dev, const char *app)
-{
-	const char *argv[4];
+static void getterm(char *dev, char *app)
+{
+	char *argv[4];
 	char term[DEVMAP_NAME_MAXLEN];
 	int rc;
Index: uspace/app/redir/redir.c
===================================================================
--- uspace/app/redir/redir.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/redir/redir.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -72,5 +72,5 @@
 static task_id_t spawn(int argc, char *argv[])
 {
-	const char **args = (const char **) calloc(argc + 1, sizeof(char *));
+	char **args = (char **) calloc(argc + 1, sizeof(char *));
 	if (!args) {
 		printf("No memory available\n");
Index: uspace/app/tester/console/console1.c
===================================================================
--- uspace/app/tester/console/console1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/console/console1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,5 +36,5 @@
 #include "../tester.h"
 
-static const char *color_name[] = {
+const char *color_name[] = {
 	[COLOR_BLACK] = "black",
 	[COLOR_BLUE] = "blue",
@@ -47,5 +47,5 @@
 };
 
-const char *test_console1(void)
+char *test_console1(void)
 {
 	if (!test_quiet) {
Index: uspace/app/tester/fault/fault1.c
===================================================================
--- uspace/app/tester/fault/fault1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/fault/fault1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -30,5 +30,5 @@
 #include "../tester.h"
 
-const char *test_fault1(void)
+char *test_fault1(void)
 {
 	((int *)(0))[1] = 0;
Index: uspace/app/tester/fault/fault2.c
===================================================================
--- uspace/app/tester/fault/fault2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/fault/fault2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -32,5 +32,5 @@
 typedef int __attribute__((may_alias)) aliasing_int;
 
-const char *test_fault2(void)
+char *test_fault2(void)
 {
 	volatile long long var;
Index: uspace/app/tester/fault/fault3.c
===================================================================
--- uspace/app/tester/fault/fault3.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/fault/fault3.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -30,5 +30,5 @@
 #include <stdlib.h>
 
-const char *test_fault3(void)
+char *test_fault3(void)
 {
 	abort();
Index: uspace/app/tester/fault/fault3.def
===================================================================
--- uspace/app/tester/fault/fault3.def	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/fault/fault3.def	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -3,4 +3,4 @@
 	"Abort",
 	&test_fault3,
-	false
+	true
 },
Index: uspace/app/tester/ipc/connect.c
===================================================================
--- uspace/app/tester/ipc/connect.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/ipc/connect.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -39,5 +39,5 @@
 }
 
-const char *test_connect(void)
+char *test_connect(void)
 {
 	TPRINTF("Connecting to %u...", IPC_TEST_SERVICE);
Index: uspace/app/tester/ipc/ping_pong.c
===================================================================
--- uspace/app/tester/ipc/ping_pong.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/ipc/ping_pong.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -38,5 +38,5 @@
 #define COUNT_GRANULARITY  100
 
-const char *test_ping_pong(void)
+char *test_ping_pong(void)
 {
 	TPRINTF("Pinging ns server for %d seconds...", DURATION_SECS);
Index: uspace/app/tester/ipc/register.c
===================================================================
--- uspace/app/tester/ipc/register.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/ipc/register.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -74,5 +74,5 @@
 }
 
-const char *test_register(void)
+char *test_register(void)
 {
 	async_set_client_connection(client_connection);
Index: uspace/app/tester/loop/loop1.c
===================================================================
--- uspace/app/tester/loop/loop1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/loop/loop1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-const char *test_loop1(void)
+char *test_loop1(void)
 {
 	TPRINTF("Looping...");
Index: uspace/app/tester/mm/malloc1.c
===================================================================
--- uspace/app/tester/mm/malloc1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/mm/malloc1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -73,5 +73,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 	sp_term_cond_s cond;
 	sp_action_prob_s prob;
@@ -90,5 +90,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 	ph_alloc_size_s alloc;
 	subphase_s *subphases;
@@ -628,5 +628,5 @@
 }
 
-const char *test_malloc1(void)
+char *test_malloc1(void)
 {
 	init_mem();
Index: uspace/app/tester/print/print1.c
===================================================================
--- uspace/app/tester/print/print1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/print/print1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-const char *test_print1(void)
+char *test_print1(void)
 {
 	TPRINTF("Testing printf(\"%%*.*s\", 5, 3, \"text\"):\n");
Index: uspace/app/tester/print/print2.c
===================================================================
--- uspace/app/tester/print/print2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/print/print2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-const char *test_print2(void)
+char *test_print2(void)
 {
 	TPRINTF("Testing printf(\"%%c %%3.2c %%-3.2c %%2.3c %%-2.3c\", 'a', 'b', 'c', 'd', 'e'):\n");
Index: uspace/app/tester/print/print3.c
===================================================================
--- uspace/app/tester/print/print3.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/print/print3.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -34,5 +34,5 @@
 #define BUFFER_SIZE  32
 
-const char *test_print3(void)
+char *test_print3(void)
 {
 	char buffer[BUFFER_SIZE];
Index: uspace/app/tester/print/print4.c
===================================================================
--- uspace/app/tester/print/print4.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/print/print4.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-const char *test_print4(void)
+char *test_print4(void)
 {
 	TPRINTF("ASCII printable characters (32 - 127) using printf(\"%%c\") and printf(\"%%lc\"):\n");
Index: uspace/app/tester/stdio/stdio1.c
===================================================================
--- uspace/app/tester/stdio/stdio1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/stdio/stdio1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,8 +36,8 @@
 static char buf[BUF_SIZE + 1];
 
-const char *test_stdio1(void)
+char *test_stdio1(void)
 {
 	FILE *file;
-	const char *file_name = "/readme";
+	char *file_name = "/readme";
 	
 	TPRINTF("Open file \"%s\"...", file_name);
Index: uspace/app/tester/stdio/stdio2.c
===================================================================
--- uspace/app/tester/stdio/stdio2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/stdio/stdio2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -32,8 +32,8 @@
 #include "../tester.h"
 
-const char *test_stdio2(void)
+char *test_stdio2(void)
 {
 	FILE *file;
-	const char *file_name = "/test";
+	char *file_name = "/test";
 	
 	TPRINTF("Open file \"%s\" for writing...", file_name);
Index: uspace/app/tester/tester.c
===================================================================
--- uspace/app/tester/tester.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/tester.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -69,5 +69,5 @@
 {
 	/* Execute the test */
-	const char *ret = test->entry();
+	char *ret = test->entry();
 	
 	if (ret == NULL) {
Index: uspace/app/tester/tester.h
===================================================================
--- uspace/app/tester/tester.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/tester.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,30 +54,30 @@
 	}
 
-typedef const char *(*test_entry_t)(void);
+typedef char *(*test_entry_t)(void);
 
 typedef struct {
-	const char *name;
-	const char *desc;
+	char *name;
+	char *desc;
 	test_entry_t entry;
 	bool safe;
 } test_t;
 
-extern const char *test_thread1(void);
-extern const char *test_print1(void);
-extern const char *test_print2(void);
-extern const char *test_print3(void);
-extern const char *test_print4(void);
-extern const char *test_console1(void);
-extern const char *test_stdio1(void);
-extern const char *test_stdio2(void);
-extern const char *test_fault1(void);
-extern const char *test_fault2(void);
-extern const char *test_fault3(void);
-extern const char *test_vfs1(void);
-extern const char *test_ping_pong(void);
-extern const char *test_register(void);
-extern const char *test_connect(void);
-extern const char *test_loop1(void);
-extern const char *test_malloc1(void);
+extern char *test_thread1(void);
+extern char *test_print1(void);
+extern char *test_print2(void);
+extern char *test_print3(void);
+extern char *test_print4(void);
+extern char *test_console1(void);
+extern char *test_stdio1(void);
+extern char *test_stdio2(void);
+extern char *test_fault1(void);
+extern char *test_fault2(void);
+extern char *test_fault3(void);
+extern char *test_vfs1(void);
+extern char *test_ping_pong(void);
+extern char *test_register(void);
+extern char *test_connect(void);
+extern char *test_loop1(void);
+extern char *test_malloc1(void);
 
 extern test_t tests[];
Index: uspace/app/tester/thread/thread1.c
===================================================================
--- uspace/app/tester/thread/thread1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/thread/thread1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -50,8 +50,8 @@
 }
 
-const char *test_thread1(void)
+char *test_thread1(void)
 {
 	unsigned int i;
-	atomic_count_t total = 0;
+	int total = 0;
 	
 	atomic_set(&finish, 1);
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tester/vfs/vfs1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,5 +54,5 @@
 static char text[] = "Lorem ipsum dolor sit amet, consectetur adipisicing elit";
 
-static const char *read_root(void)
+static char *read_root(void)
 {
 	TPRINTF("Opening the root directory...");
@@ -73,5 +73,5 @@
 }
 
-const char *test_vfs1(void)
+char *test_vfs1(void)
 {
 	if (mkdir(MOUNT_POINT, 0) != 0)
@@ -121,5 +121,5 @@
 	close(fd0);
 	
-	const char *rv = read_root();
+	char *rv = read_root();
 	if (rv != NULL)
 		return rv;
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tetris/screen.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -72,5 +72,5 @@
  * simply literal strings);
  */
-static inline void putstr(const char *s)
+static inline void putstr(char *s)
 {
 	while (*s)
@@ -181,5 +181,5 @@
 }
 
-void stop(const char *why)
+void stop(char *why)
 {
 	if (isset)
Index: uspace/app/tetris/tetris.h
===================================================================
--- uspace/app/tetris/tetris.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/tetris/tetris.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -186,5 +186,5 @@
 extern int fits_in(const struct shape *, int);
 extern void place(const struct shape *, int, int);
-extern void stop(const char *);
+extern void stop(char *);
 
 /** @}
Index: uspace/app/trace/errors.h
===================================================================
--- uspace/app/trace/errors.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/errors.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,6 +37,6 @@
 
 typedef struct {
-	const char *name;  /**< Error value name (Exx) */
-	const char *desc;  /**< Error description */
+	char *name;	/**< Error value name (Exx) */
+	char *desc;	/**< Error description */
 } err_desc_t;
 
Index: uspace/app/trace/ipc_desc.h
===================================================================
--- uspace/app/trace/ipc_desc.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/ipc_desc.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -38,5 +38,5 @@
 typedef struct {
 	int number;
-	const char *name;
+	char *name;
 } ipc_m_desc_t;
 
Index: uspace/app/trace/proto.c
===================================================================
--- uspace/app/trace/proto.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/proto.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -157,5 +157,5 @@
 }
 
-static void proto_struct_init(proto_t *proto, const char *name)
+static void proto_struct_init(proto_t *proto, char *name)
 {
 	proto->name = name;
@@ -164,5 +164,5 @@
 }
 
-proto_t *proto_new(const char *name)
+proto_t *proto_new(char *name)
 {
 	proto_t *p;
@@ -206,10 +206,10 @@
 }
 
-static void oper_struct_init(oper_t *oper, const char *name)
+static void oper_struct_init(oper_t *oper, char *name)
 {
 	oper->name = name;
 }
 
-oper_t *oper_new(const char *name, int argc, val_type_t *arg_types,
+oper_t *oper_new(char *name, int argc, val_type_t *arg_types,
     val_type_t rv_type, int respc, val_type_t *resp_types)
 {
Index: uspace/app/trace/proto.h
===================================================================
--- uspace/app/trace/proto.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/proto.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -43,5 +43,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 
 	int argc;
@@ -56,5 +56,5 @@
 typedef struct {
 	/** Protocol name */
-	const char *name;
+	char *name;
 
 	/** Maps method number to operation */
@@ -70,10 +70,10 @@
 void proto_register(int srv, proto_t *proto);
 proto_t *proto_get_by_srv(int srv);
-proto_t *proto_new(const char *name);
+proto_t *proto_new(char *name);
 void proto_delete(proto_t *proto);
 void proto_add_oper(proto_t *proto, int method, oper_t *oper);
 oper_t *proto_get_oper(proto_t *proto, int method);
 
-oper_t *oper_new(const char *name, int argc, val_type_t *arg_types,
+oper_t *oper_new(char *name, int argc, val_type_t *arg_types,
     val_type_t rv_type, int respc, val_type_t *resp_types);
 
Index: uspace/app/trace/syscalls.h
===================================================================
--- uspace/app/trace/syscalls.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/syscalls.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -39,5 +39,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 	int n_args;
 	val_type_t rv_type;
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/trace/trace.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -585,5 +585,5 @@
 }
 
-static loader_t *preload_task(const char *path, char **argv,
+static loader_t *preload_task(const char *path, char *const argv[],
     task_id_t *task_id)
 {
@@ -591,5 +591,5 @@
 	int rc;
 
-	/* Spawn a program loader */
+	/* Spawn a program loader */	
 	ldr = loader_connect();
 	if (ldr == NULL)
@@ -607,5 +607,5 @@
 
 	/* Send arguments */
-	rc = loader_set_args(ldr, (const char **) argv);
+	rc = loader_set_args(ldr, argv);
 	if (rc != EOK)
 		goto error;
@@ -870,31 +870,25 @@
 }
 
-static display_mask_t parse_display_mask(const char *text)
+static display_mask_t parse_display_mask(char *text)
 {
 	display_mask_t dm;
-	const char *c = text;
-	
+	char *c;
+
+	c = text;
+
 	while (*c) {
 		switch (*c) {
-		case 't':
-			dm = dm | DM_THREAD;
-			break;
-		case 's':
-			dm = dm | DM_SYSCALL;
-			break;
-		case 'i':
-			dm = dm | DM_IPC;
-			break;
-		case 'p':
-			dm = dm | DM_SYSTEM | DM_USER;
-			break;
+		case 't': dm = dm | DM_THREAD; break;
+		case 's': dm = dm | DM_SYSCALL; break;
+		case 'i': dm = dm | DM_IPC; break;
+		case 'p': dm = dm | DM_SYSTEM | DM_USER; break;
 		default:
 			printf("Unexpected event type '%c'.\n", *c);
 			exit(1);
 		}
-		
+
 		++c;
 	}
-	
+
 	return dm;
 }
@@ -902,13 +896,13 @@
 static int parse_args(int argc, char *argv[])
 {
+	char *arg;
 	char *err_p;
 
 	task_id = 0;
 
-	--argc;
-	++argv;
+	--argc; ++argv;
 
 	while (argc > 0) {
-		char *arg = *argv;
+		arg = *argv;
 		if (arg[0] == '+') {
 			display_mask = parse_display_mask(&arg[1]);
@@ -916,6 +910,5 @@
 			if (arg[1] == 't') {
 				/* Trace an already running task */
-				--argc;
-				++argv;
+				--argc; ++argv;
 				task_id = strtol(*argv, &err_p, 10);
 				task_ldr = NULL;
@@ -934,12 +927,10 @@
 			break;
 		}
-		
-		--argc;
-		++argv;
+
+		--argc; ++argv;
 	}
 
 	if (task_id != 0) {
-		if (argc == 0)
-			return 0;
+		if (argc == 0) return 0;
 		printf("Extra arguments\n");
 		print_syntax();
@@ -955,9 +946,8 @@
 	/* Preload the specified program file. */
 	printf("Spawning '%s' with arguments:\n", *argv);
-	
-	char **cp = argv;
-	while (*cp)
-		printf("'%s'\n", *cp++);
-	
+	{
+		char **cp = argv;
+		while (*cp) printf("'%s'\n", *cp++);
+	}
 	task_ldr = preload_task(*argv, argv, &task_id);
 	task_wait_for = true;
Index: uspace/lib/libc/Makefile.toolchain
===================================================================
--- uspace/lib/libc/Makefile.toolchain	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/Makefile.toolchain	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,26 +27,22 @@
 #
 
-OPTIMIZATION = 3
-
-GCC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
+GCC_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-Werror -pipe -g -D__$(ENDIANESS)__
+	-Werror-implicit-function-declaration -Werror -pipe -g -D__$(ENDIANESS)__
 
-ICC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-Werror -pipe -g -D__$(ENDIANESS)__
-
-CLANG_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
+ICC_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe -g -arch $(CLANG_ARCH) -D__$(ENDIANESS)__
+	-Werror-implicit-function-declaration -Werror -pipe -g -D__$(ENDIANESS)__
+
+CLANG_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
+	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
+	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
+	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+	-Werror-implicit-function-declaration -pipe -g -arch $(CLANG_ARCH) \
+	-D__$(ENDIANESS)__
 
 LFLAGS = -M -N $(SOFTINT_PREFIX)/libsoftint.a
Index: uspace/lib/libc/arch/abs32le/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/abs32le/Makefile.inc	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/abs32le/Makefile.inc	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,8 +46,4 @@
 endif
 
-ifeq ($(COMPILER),clang)
-	CLANG_ARCH = i386
-endif
-
 ARCH_SOURCES = \
 	arch/$(UARCH)/src/entry.c \
Index: uspace/lib/libc/arch/abs32le/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/abs32le/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/abs32le/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -43,5 +43,5 @@
 #include <atomicdflt.h>
 
-static inline bool cas(atomic_t *val, atomic_count_t ov, atomic_count_t nv)
+static inline bool cas(atomic_t *val, long ov, long nv)
 {
 	if (val->count == ov) {
@@ -67,5 +67,5 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	/* On real hardware both the storing of the previous
@@ -73,5 +73,5 @@
 	   atomic action. */
 	
-	atomic_count_t prev = val->count;
+	long prev = val->count;
 	
 	val->count++;
@@ -79,5 +79,5 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	/* On real hardware both the storing of the previous
@@ -85,5 +85,5 @@
 	   atomic action. */
 	
-	atomic_count_t prev = val->count;
+	long prev = val->count;
 	
 	val->count--;
Index: uspace/lib/libc/arch/abs32le/include/types.h
===================================================================
--- uspace/lib/libc/arch/abs32le/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/abs32le/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,6 +54,4 @@
 
 typedef uint32_t uintptr_t;
-typedef uint32_t atomic_count_t;
-typedef int32_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/arch/amd64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/amd64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/amd64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -42,28 +42,33 @@
 #include <atomicdflt.h>
 
-static inline void atomic_inc(atomic_t *val)
-{
-	asm volatile (
-		"lock incq %[count]\n"
-		: [count] "+m" (val->count)
-	);
+static inline void atomic_inc(atomic_t *val) {
+	asm volatile ("lock incq %0\n" : "+m" (val->count));
 }
 
-static inline void atomic_dec(atomic_t *val)
-{
-	asm volatile (
-		"lock decq %[count]\n"
-		: [count] "+m" (val->count)
-	);
+static inline void atomic_dec(atomic_t *val) {
+	asm volatile ("lock decq %0\n" : "+m" (val->count));
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val) 
 {
-	atomic_count_t r = 1;
+	long r;
+
+	asm volatile (
+		"movq $1, %0\n"
+		"lock xaddq %0, %1\n"
+		: "=r" (r), "+m" (val->count)
+	);
+
+	return r;
+}
+
+static inline long atomic_postdec(atomic_t *val) 
+{
+	long r;
 	
 	asm volatile (
-		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"movq $-1, %0\n"
+		"lock xaddq %0, %1\n"
+		: "=r" (r), "+m" (val->count)
 	);
 	
@@ -71,19 +76,6 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
-{
-	atomic_count_t r = -1;
-	
-	asm volatile (
-		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
-	);
-	
-	return r;
-}
-
-#define atomic_preinc(val)  (atomic_postinc(val) + 1)
-#define atomic_predec(val)  (atomic_postdec(val) - 1)
+#define atomic_preinc(val) (atomic_postinc(val) + 1)
+#define atomic_predec(val) (atomic_postdec(val) - 1)
 
 #endif
Index: uspace/lib/libc/arch/amd64/include/types.h
===================================================================
--- uspace/lib/libc/arch/amd64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/amd64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,6 +54,4 @@
 
 typedef uint64_t uintptr_t;
-typedef uint64_t atomic_count_t;
-typedef int64_t atomic_signed_t;
 
 #endif
